//+------------------------------------------------------------------+
//| ANLL.BARS                                                        |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DarkSlateGray
#property indicator_color2 DarkSlateGray
#property indicator_color3 DodgerBlue
#property indicator_color4 Crimson
#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 4
#property indicator_width4 4

int forced_tf = 0;
extern int period     = 14;
int price  = PRICE_TYPICAL;


double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double prices[];
double lwma1[];
double lwma2[];
int tf;


//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,lwma2); SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(5,lwma1); SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(6,prices);SetIndexStyle(6,DRAW_NONE);
 
   return(0);
}


int deinit()
{
   return(0);
}


int start()
{
   double sum,sumw,weight;
   int i,k,limit,counted_bars=IndicatorCounted();
   
   if(forced_tf != 0) tf = forced_tf;
      else tf = Period();
      
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars+period,Bars-1);
 
   
            
   for(i=limit; i>=0; i--) prices[i] = iMA(NULL,tf,1,0,MODE_SMA,price,i+1);
   for(i=limit; i>=0; i--)
   {  
      for(k=0, sum=0, sumw=0; k<period && (i+k)<Bars; k++) { weight = period-k; sumw += weight; sum += weight*prices[i+k]; }
      if (sumw!=0)
            lwma1[i] = sum/sumw;
      else  lwma1[i] = 0;
   }      
   for(i=0; i<=limit; i++)
   {
      for(k=0, sum=0, sumw=0; k<period && (i-k)>=0; k++) { weight = period-k; sumw += weight; sum += weight*lwma1[i-k]; }             
      if (sumw!=0)
            lwma2[i] = sum/sumw;
      else  lwma2[i] = 0;
      
      double median = lwma1[i]; 
      double medias = lwma2[i];
            
      
      
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
      buffer3[i] = EMPTY_VALUE;
      buffer4[i] = EMPTY_VALUE;
      
      
         if (median < medias)
            {
              buffer1[i] = High[i];
              buffer2[i] = Low[i];
              if (Close[i]>Open[i]) { buffer3[i] = Close[i]; buffer4[i] = Open[i]; }  
              else                  { buffer4[i] = Close[i]; buffer3[i] = Open[i]; }  
            }                   
         if (median > medias)
            {
               buffer1[i] = Low[i];
               buffer2[i] = High[i];
               if (Close[i]<Open[i]) { buffer3[i] = Close[i]; buffer4[i] = Open[i]; }  
               else                  { buffer4[i] = Close[i]; buffer3[i] = Open[i]; }  
            }                   
         
   }
   return(0);
}